﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.IO.Ports;

namespace AvlF8101
{
    /// <summary>
    /// ComSettingWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class ComSettingWindow : Window
    {
        public ComSettingWindow()
        {
            InitializeComponent();
        }

        public string Port { get; set; }
        public int BaudRate { get; set; }
        public int DataBits { get; set; }
        public Parity Parity { get; set; }
        public StopBits StopBits { get; set; }

        private void PortComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var com in SerialPort.GetPortNames()) 
            {
                PortComboBox.Items.Add(com);
            }
            PortComboBox.SelectedItem = Port;
        }

        private readonly int[] _BaudRateArray = new int[] { 110, 300, 600, 1200, 2400, 4800, 9600, 14400, 19200, 38400, 57600, 115200, 230400, 460800, 921600 };

        private void BaudrateComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var item in _BaudRateArray)
            {
                BaudrateComboBox.Items.Add(item);
            }
            BaudrateComboBox.SelectedItem = BaudRate;
        }

        private readonly int[] _DataBitsArray = new int[] { 7, 8 };

        private void DataComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var item in _DataBitsArray)
            {
                DataComboBox.Items.Add(item);
            }
            DataComboBox.SelectedItem = DataBits;
        }

        private readonly Parity[] _ParityArray = new Parity[] { Parity.Even, Parity.Mark, Parity.None, Parity.Odd, Parity.Space };

        private void ParityComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var item in _ParityArray)
            {
                ParityComboBox.Items.Add(item);
            }
            ParityComboBox.SelectedValue = Parity;
        }

        private readonly StopBits[] _StopBitsArray = new StopBits[] { StopBits.One, StopBits.OnePointFive, StopBits.Two };

        private void StopComboBox_Loaded(object sender, RoutedEventArgs e)
        {
            foreach (var item in _StopBitsArray)
            {
                StopComboBox.Items.Add(item);
            }
            StopComboBox.SelectedValue = StopBits;
        }

        private void OkButton_Click(object sender, RoutedEventArgs e)
        {
            Port = (String)PortComboBox.SelectedItem;
            BaudRate = (int)BaudrateComboBox.SelectedItem;
            DataBits = (int)DataComboBox.SelectedItem;
            Parity = (Parity)ParityComboBox.SelectedValue;
            StopBits = (StopBits)StopComboBox.SelectedValue;
            this.DialogResult = true;
        }
    }
}
