﻿using System;
using System.Windows.Input;

namespace AvlF8101
{
    class MainWindowViewModel
    {
        public delegate void InvokeScriptHandler(string scriptName, params object[] args);

        public MainWindowViewModel(string uri, InvokeScriptHandler invokeScript)
        {
            this._invokeScript = invokeScript;
            this.Uri = uri;
            this.MapHost = new MapHost();
            this.ShowMarkerCommand = new DelegateCommand(() => { this._invokeScript("showMarker", getCurrentId()); });
        }

        private InvokeScriptHandler _invokeScript;

        public ICommand ShowMarkerCommand { get; private set; }

        public MapHost MapHost { get; private set; }

        public string Uri { get; private set; }

        private string getCurrentId()
        {
            if (this.MapHost.SelectedMarker == null)
            {
                return "";
            }
            return this.MapHost.SelectedMarker.Id;
        }
    }
}
