﻿var map;
var geo; 
var tilesloadedHandle;
var markers = {};

// 初期化
function initialize()
{
	map = new google.maps.Map(document.getElementById("map_canvas"), 
		{
			zoom: 10,
			center: new google.maps.LatLng(47.711947, -122.156166), 
			mapTypeId: google.maps.MapTypeId.ROADMAP, 
			scaleControl: true
		});
	geo = new google.maps.Geocoder();
	
	// tilesloaded: 見える範囲のタイル読み込み完了
	tilesloadedHandle = google.maps.event.addListener(map, 'tilesloaded', function()
	{
		google.maps.event.removeListener(tilesloadedHandle);
	});
}

// マーカー追加
function addMarker(id)
{
	var center = map.getCenter();
	var marker = new google.maps.Marker({position: center, map: map, draggable: false});
	marker.setTitle(id);
	marker.id = id;

	window.external.OnMarkerAdded(marker.id, marker.position.lat(), marker.position.lng() );

	google.maps.event.addListener(marker, 'position_changed', function()
	{
		window.external.OnMarkerMoved(marker.id, marker.position.lat(), marker.position.lng());
	});
	markers[id] = marker;
}

function moveMarker(id, latitude, longitude)
{
	if (!(id in markers))
	{
		addMarker(id);
	}
	markers[id].setPosition({lat: latitude, lng: longitude});
}

function showMarker(id)
{
	if (id in markers)
	{
		map.setCenter(markers[id].position);
	}
}


